<template functional>
  <section
    :ref="data.ref"
    class="section relative"
    :class="[data.class, data.staticClass]"
    :style="[data.style, data.staticStyle]"
    v-bind="data.attrs"
    v-on="listeners"
  >
    <!-- Cover Image -->
    <div
      class="h-full"
      :class="[
        {
          'fx-overlay fx-ovl-color':
            props.overlay.color || props.overlay.opacity,
        },
      ]"
      :style="{
        '--fx-overlay-color': props.overlay.color,
        '--fx-overlay-opacity': props.overlay.opacity,
      }"
    >
      <g-image
        :src="props.coverImage.image"
        :alt="props.coverImage.description"
        class="h-full w-full object-center object-cover"
      />
    </div>

    <!-- Cover Content -->
    <div class="absolute inset-0 flex justify-center items-center">
      <slot />
    </div>
  </section>
</template>

<script>
export default {
  name: 'CoverSection',
  props: {
    coverImage: {
      type: Object,
      default: () => ({ image: undefined, description: undefined }),
      required: true,
    },
    overlay: {
      type: Object,
      default: () => ({ color: undefined, opacity: undefined }),
    },
  },
};
</script>

<style lang="postcss" scoped>
.section {
  --section-h: theme('height.screen-60');

  height: var(--section-h);
}
@screen lg {
  .section {
    --section-h: calc(100vh - var(--g-navbar-h));
  }
}
</style>
